using System;
using System.Linq;

namespace MyShootingStar
{
    class Program
    {
        static void Main(string[] args)
        {
            int N = Convert.ToInt32(Console.ReadLine());
            string s1 = Console.ReadLine();
            int o = Convert.ToInt32(s1.Split(' ')[0]);
            int a = Convert.ToInt32(s1.Split(' ')[1]);
            int b = Convert.ToInt32(s1.Split(' ')[2]);
            int ab = Convert.ToInt32(s1.Split(' ')[3]);
            string rez = "moguce";
            string[,] matrica = new string[N, 7];
            for (int i = 0; i < N; i++)
            {
                for (int m = 0; m < 7; m++)
                {
                    if (m % 2 == 0)
                        matrica[i, m] = "0";
                    else
                        matrica[i, m] = " ";
                }
            }
            for (int i = 0; i < N; i++)
            {
                string s = Console.ReadLine();
                string grupa = Convert.ToString(s.Split(' ')[0]);
                int brJedinica = Convert.ToInt32(s.Split(' ')[1]);
                if (grupa == "O")
                {
                    if (brJedinica > o)
                    {
                        rez = "nemoguce";
                        break;
                    }
                    else
                    {
                        o -= brJedinica;
                        matrica[i, 0] += brJedinica;
                    }
                }
                else if (grupa == "A")
                {
                    if (brJedinica > a + o)
                    {
                        rez = "nemoguce";
                        break;
                    }
                    else
                    {
                        if (Math.Max(a, o) >= brJedinica)
                        {
                            if (Math.Max(a, o) == a)
                            {
                                a -= brJedinica;
                                matrica[i, 2] = Convert.ToString(brJedinica);
                            }
                            else
                            {
                                o -= brJedinica;
                                matrica[i, 0] = Convert.ToString(brJedinica);
                            }
                        }
                        else
                        {
                            if (Math.Max(a, o) == a)
                            {
                                matrica[i, 2] = Convert.ToString(a);
                                matrica[i, 0] = Convert.ToString(brJedinica - a);
                                a = 0;
                                o -= brJedinica - a;
                            }
                            else
                            {
                                matrica[i, 0] = Convert.ToString(o);
                                matrica[i, 2] = Convert.ToString(brJedinica - o);
                                o = 0;
                                a -= brJedinica - o;
                            }
                        }
                    }
                }
                else if (grupa == "B")
                {
                    if (brJedinica > b + o)
                    {
                        rez = "nemoguce";
                        break;
                    }
                    else
                    {
                        if (Math.Max(b, o) >= brJedinica)
                        {
                            if (Math.Max(b, o) == b)
                            {
                                b -= brJedinica;
                                matrica[i, 4] = Convert.ToString(brJedinica);
                            }
                            else
                            {
                                o -= brJedinica;
                                matrica[i, 0] = Convert.ToString(brJedinica);
                            }
                        }
                        else
                        {
                            if (Math.Max(b, o) == b)
                            {
                                matrica[i, 4] = Convert.ToString(b);
                                matrica[i, 0] = Convert.ToString(brJedinica - o);
                                b = 0;
                                o -= brJedinica - b;
                            }
                            else
                            {
                                matrica[i, 0] = Convert.ToString(o);
                                matrica[i, 4] = Convert.ToString(brJedinica - o);
                                o = 0;
                                b -= brJedinica - o;
                            }
                        }
                    }
                }
            }
            if (rez == "nemoguce")
            {
                Console.WriteLine(rez);
            }
            else
            {
                Console.WriteLine(rez);
                for (int i = 0; i < N; i++)
                {
                    for (int m = 0; m < 7; m++) 
                    {
                        Console.Write(matrica[i, m]);
                    }
                    Console.WriteLine(" ");
                }
            }
            Console.WriteLine();
        }
    }

}